/*-------------------------------------------------------------------
[SCRIPT] Service Broker Sample - Source activation   
[DATABASE] 
[DESCRIPTION] 
[MAJ PAR] DATAFLY - Arian Papillon
[DATEMAJ] SQL Saturday - 05/09/2015  
-------------------------------------------------------------------*/
USE SBSource
GO
CREATE PROCEDURE Broker_Receive_Message
AS
BEGIN
    SET NOCOUNT ON   -- dbut de procedure
    DECLARE @conversation UNIQUEIDENTIFIER
    DECLARE @msg xml
    DECLARE @msgType NVARCHAR(256)
    ;RECEIVE TOP(1) 
		@conversation = conversation_handle,
	    @msgType = message_type_name, 
		@msg = message_body
    FROM DataModification_Queue;
    IF (@msgType = 'http://schemas.microsoft.com/SQL/ServiceBroker/Error') OR
    	(@msgType = 'http://schemas.microsoft.com/SQL/ServiceBroker/EndDialog')
		BEGIN
    		END CONVERSATION @conversation
		END
END

ALTER QUEUE DataModification_Queue   -- enclenche l'activation et dmarre la queue
WITH STATUS = ON,
     ACTIVATION ( 
		STATUS = ON,
		PROCEDURE_NAME = Broker_Receive_Message, 	
		MAX_QUEUE_READERS = 1,
		EXECUTE AS OWNER)

--ALTER QUEUE Person_DataModification_Queue   -- enclenche l'activation et dmarre la queue
--WITH STATUS = ON,
--     ACTIVATION ( 
--		STATUS = OFF)
